function y = spin_MV(n,v)
%Annika Savelsberg

if ~mod(n,3)
    m=n/3;
    y(1:m,1)      =v(1:m)          -2*sum(v(m+1:2*m))    +v(3*m:-1:2*m+1);
    y(m+1:2*m,1)  =-3*sum(v(1:m))  +3*sum(v(2*m+1:3*m));
    y(2*m+1:3*m)  =-1*y(m:-1:1,1);
    
elseif ~mod(n,2)
    m=n/2;
    y(1:m,1)      =v(1:m)          +v(2*m:-1:m+1);
    y(m+1:2*m,1)  =-1*y(m:-1:1);
    
else
    m=floor(n/2);
    y(1:m,1)      =v(1:m)          -2*v(m+1)             +v(2*m+1:-1:m+2);
    y(m+1)        =-3*sum(v(1:m))  +3*sum(v(m+2:2*m+1));
    y(m+2:2*m+1)  =-1*y(m:-1:1);

end
end